#ifndef __PCA9685_H
#define __PCA9685_H

#define PCA9685_FIXED_ADDRESS               0x80
/* Slave addresses default values */
#define PCA9685_ALLCALL_DEFVALUE    0xE0
#define PCA9685_SWRESET_DEFVALUE    0x06
#define PCA9685_SUBCALL1_DEFVALUE   0xE2
#define PCA9685_SUBCALL2_DEFVALUE   0xE4
#define PCA9685_SUBCALL3_DEFVALUE   0xE8

/* Registers */
#define PCA9685_MODE1               0x00
#define PCA9685_MODE2               0x01
#define PCA9685_SUBADR1             0x02
#define PCA9685_SUBADR2             0x03
#define PCA9685_SUBADR3             0x04
#define PCA9685_ALLCALLADR          0x05
#define PCA9685_SERVO0_ON_L         0x06
#define PCA9685_SERVO0_ON_H         0x07
#define PCA9685_SERVO0_OFF_L        0x08
#define PCA9685_SERVO0_OFF_H        0x09
#define PCA9685_SERVO1_ON_L         0x0a
#define PCA9685_SERVO1_ON_H         0x0b
#define PCA9685_SERVO1_OFF_L        0x0c
#define PCA9685_SERVO1_OFF_H        0x0d
#define PCA9685_SERVO2_ON_L         0x0e
#define PCA9685_SERVO2_ON_H         0x0f
#define PCA9685_SERVO2_OFF_L        0x10
#define PCA9685_SERVO2_OFF_H        0x11
#define PCA9685_SERVO3_ON_L         0x12
#define PCA9685_SERVO3_ON_H         0x13
#define PCA9685_SERVO3_OFF_L        0x14
#define PCA9685_SERVO3_OFF_H        0x15
#define PCA9685_SERVO4_ON_L         0x16
#define PCA9685_SERVO4_ON_H         0x17
#define PCA9685_SERVO4_OFF_L        0x18
#define PCA9685_SERVO4_OFF_H        0x19
#define PCA9685_SERVO5_ON_L         0x1a
#define PCA9685_SERVO5_ON_H         0x1b
#define PCA9685_SERVO5_OFF_L        0x1c
#define PCA9685_SERVO5_OFF_H        0x1d
#define PCA9685_SERVO6_ON_L         0x1e
#define PCA9685_SERVO6_ON_H         0x1d
#define PCA9685_SERVO6_OFF_L        0x20
#define PCA9685_SERVO6_OFF_H        0x21
#define PCA9685_SERVO7_ON_L         0x22
#define PCA9685_SERVO7_ON_H         0x23
#define PCA9685_SERVO7_OFF_L        0x24
#define PCA9685_SERVO7_OFF_H        0x25
#define PCA9685_SERVO8_ON_L         0x26
#define PCA9685_SERVO8_ON_H         0x27
#define PCA9685_SERVO8_OFF_L        0x28
#define PCA9685_SERVO8_OFF_H        0x29
#define PCA9685_SERVO9_ON_L         0x2a
#define PCA9685_SERVO9_ON_H         0x2b
#define PCA9685_SERVO9_OFF_L        0x2c
#define PCA9685_SERVO9_OFF_H        0x2d
#define PCA9685_SERVO10_ON_L        0x2e
#define PCA9685_SERVO10_ON_H        0x2f
#define PCA9685_SERVO10_OFF_L       0x30
#define PCA9685_SERVO10_OFF_H       0x31
#define PCA9685_SERVO11_ON_L        0x32
#define PCA9685_SERVO11_ON_H        0x33
#define PCA9685_SERVO11_OFF_L       0x34
#define PCA9685_SERVO11_OFF_H       0x35
#define PCA9685_SERVO12_ON_L        0x36
#define PCA9685_SERVO12_ON_H        0x37
#define PCA9685_SERVO12_OFF_L       0x38
#define PCA9685_SERVO12_OFF_H       0x39
#define PCA9685_SERVO13_ON_L        0x3a
#define PCA9685_SERVO13_ON_H        0x3b
#define PCA9685_SERVO13_OFF_L       0x3c
#define PCA9685_SERVO13_OFF_H       0x3d
#define PCA9685_SERVO14_ON_L        0x3e
#define PCA9685_SERVO14_ON_H        0x3f
#define PCA9685_SERVO14_OFF_L       0x40
#define PCA9685_SERVO14_OFF_H       0x41
#define PCA9685_SERVO15_ON_L        0x42
#define PCA9685_SERVO15_ON_H        0x43
#define PCA9685_SERVO15_OFF_L       0x44
#define PCA9685_SERVO15_OFF_H       0x45
#define PCA9685_ALL_SERVO_ON_L      0xfa
#define PCA9685_ALL_SERVO_ON_H      0xfb
#define PCA9685_ALL_SERVO_OFF_L     0xfc
#define PCA9685_ALL_SERVO_OFF_H     0xfd
#define PCA9685_PRE_SCALE           0xfe

/* MODE1 bits */
#define PCA9685_MODE1_RESTART   0x80
#define PCA9685_MODE1_EXTCLK    0x40
#define PCA9685_MODE1_AI        0x20
#define PCA9685_MODE1_SLEEP     0x10
#define PCA9685_MODE1_SUB1      0x08
#define PCA9685_MODE1_SUB2      0x04
#define PCA9685_MODE1_SUB3      0x02
#define PCA9685_MODE1_ALLCALL   0x01

/* MODE2 bits */
#define PCA9685_MODE2_INVRT     0x10
#define PCA9685_MODE2_OCH       0x08
#define PCA9685_MODE2_OUTDRV    0x04
#define PCA9685_MODE2_OUTNE1    0x02
#define PCA9685_MODE2_OUTNE0    0x01

/* PWM Frequency macro calculator */
#define PCA9685_PWM_FREQ(oscMhz,updRate)    ((oscMhz)/(4096*(updRate)))

#endif
